#include<bits/stdc++.h>
#define Tp template<typename Ty>
#define Ts template<typename Ty,typename... Ar>
#define Rg register
#define RI Rg int
#define Cn const
#define CI Cn int&
#define I inline
#define W while
#define X 998244353
using namespace std;
int a,b,c;
namespace S1
{
	#define A 4
	#define B 5000
	#define PP 1<<(4*A-1)
	int P,Lg[PP],p[PP],w[PP],ct[PP],Hb[PP];
	struct Data {int v,c;I Data operator + (Cn Data& o) Cn {if(v^o.v) return v>o.v?*this:o;return (Data){v,(c+o.c)%X};}};
	I void FWT(Data* s) {RI i,j,k;for(i=1;i^P;i<<=1) for(j=0;j^P;j+=i<<1) for(k=0;k^i;++k) s[i+j+k]=s[i+j+k]+s[j+k];}
	int q[PP];Data f[PP],g[PP];I void Solve()
	{
		RI i,j;memset(f,0,sizeof(f)),f[0]=(Data){0,1};
		for(P=1<<(4*a-1),i=0;i<4*a-1;++i) Lg[1<<i]=i;
		for(i=1;i^P;++i) Hb[i]=i==(i&-i)?Lg[i]:Hb[i^(i&-i)],ct[i]=ct[i>>1]+(i&1);
		for(p[0]=w[0]=i=1;i^P;++i) p[i]=p[i^(i&-i)]&&!(Lg[i&-i]&1),w[i]=w[i>>1]&&(!(i&1)||!(i&2));
		RI cc=0;for(i=0;i^P;++i) w[i]&&(q[++cc]=i);
		RI j_,P_=P-1;for(i=-2*b+1;i<=2*b-1;++i)
		{
			for(j=0;j^P;++j) g[j]=(Data){0,0};
			for(j_=1;j_<=cc;++j_) g[q[j_]|(q[j_]>>1)]=g[q[j_]|(q[j_]>>1)]+f[q[j_]];FWT(g);
			for(j_=1;j_<=cc;++j_)
			{
				if(f[j=q[j_]]=(Data){0,0},(!(i&1)&&!p[j])||!g[P_^j].c) continue;
				if(!j||-2*c+1<=Lg[j&-j]-2*a+1+i&&Hb[j]-2*a+1+i<=2*c-1) f[j]=g[P_^j],f[j].v+=ct[j];
			}
		}
		Data t({0,0});for(j=0;j^P;++j) t=t+f[j];printf("%d %d\n",t.v,t.c);
	}
}
int main()
{
	freopen("geometry.in","r",stdin),freopen("geometry.out","w",stdout);
	RI Tt;scanf("%d",&Tt);W(Tt--)
	{
		if(scanf("%d%d%d",&a,&b,&c),a<=4) {S1::Solve();continue;}
		puts("Karen!");continue;
//		if(a<=100&&b<=100&&c<=100) {S2::Solve();continue;}
	}return 0;
}